unit RadioButtonWordWrap;

{$mode objfpc}{$H+}

interface

uses
  Classes, StdCtrls, SysUtils, Windows, Graphics, Math;

type

  { TRadioButtonWordWrap }

  TRadioButtonWordWrap = class(TRadioButton)
  private
    FWordWrap: boolean;
    procedure SetWordWrap(AValue: boolean);
  protected
    procedure CalculatePreferredSize(var PreferredWidth, PreferredHeight: Integer; WithThemeSpace: Boolean); override;
    //procedure Paint; override;     <-- gibt es nicht
  public
    constructor Create(AOwner: TComponent); override;
  published
    property WordWrap: boolean read FWordWrap write SetWordWrap;
  end;


implementation


{ TRadioButtonWordWrap }

constructor TRadioButtonWordWrap.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.FWordWrap := false;
end;

procedure TRadioButtonWordWrap.SetWordWrap(AValue: boolean);
var
  rb: DWORD;
begin
  if FWordWrap = AValue then Exit;

  FWordWrap := AValue;

  rb := GetWindowLong(self.Handle, GWL_STYLE);

  if rb <> 0 then begin

     if AValue then begin
        rb := rb or BS_MULTILINE or BS_VCENTER;
     end else begin
        rb := rb and not BS_MULTILINE and not BS_VCENTER;
     end;

     SetWindowLong(self.Handle, GWL_STYLE, rb);
     self.Invalidate;
  end;

end;

procedure TRadioButtonWordWrap.CalculatePreferredSize(var PreferredWidth, PreferredHeight: Integer; WithThemeSpace: Boolean);
var
  bmp: TBitmap;
  ALines: integer;
begin
  inherited CalculatePreferredSize(PreferredWidth, PreferredHeight, WithThemeSpace);

  if self.FWordWrap then begin
     bmp := TBitmap.Create;
     bmp.Canvas.Font.Assign(self.Font);
     ALines := ceil(bmp.Canvas.TextWidth(self.Caption) / (self.Width - 25));
     PreferredHeight := ALines * bmp.Canvas.TextHeight(self.Caption);
     bmp.Free;
  end;

end;

//procedure TRadioButtonWordWrap.Paint;
//begin
  // self.canvas gibt es leider nicht...
//end;


end.

